require 'thor_dleavitt'

require 'hyrb'
require 'hyrb/command'

module Hyrb
  class CLI < Command
    class_option :verbose, :desc => "Verbose", :aliases => "-v"

    desc "edit", "Open the configuration dir in your default editor"
    def edit
      Commands::Pipeline.new(Hyrb::Task).edit(Hyrb::DEFAULT_PATH)
    end

    subc :defaults, "Manage Hyrb defaults"
    subc :creds, "Manage service credentials"
    subc :project, "Manage projects"
    subc :environment, "Manage project environments"
    subc :developers, "Manage developers"
    subc :digital_ocean, "Manage Digital Ocean SSH Keys"
    subc :hipchat, "Manage Hipchat Rooms"
    subc :github, "Manage Github Repos"
    subc :rackspace, "Manage Rackspace DNS"
    subc :provision, "Create Project Servers"
    subc :ansible, "Create Ansible Playbooks"
  end
end