module Hyrb
  module Commands
    class Project < Command
      desc "show <project>", "Show project info"
      def show(project = nil)
        pipeline(Hyrb::Tasks::Project::Show, project_name: project)
      end

      desc "create <project>", "Create a new project file"
      def create(project = nil)
        pipeline(Hyrb::Tasks::Project::Create, project_name: project)
      end

      desc "edit <project>", "Open a project file in your default editor"
      def edit(project = nil)
        pipeline(Hyrb::Tasks::Project::Edit, project_name: project)
      end

      desc "bootstrap <project>", "Build a project"
      def bootstrap(project = nil, env = nil)
        pipeline(Hyrb::Tasks::Project::Bootstrap, project_name: project)
      end

      desc "create_hipchat_hook <project>", "Link a Github repo to a Hipchat room"
      def create_hipchat_hook(project = nil)
        pipeline(Hyrb::Tasks::Project::CreateHipchatHook, project_name: project)
      end

      desc "developers <project>", "Manage developers for a project"
      def developers(project = nil)
        pipeline(Hyrb::Tasks::Developers::AddToProject, project_name: project)
      end

    end
  end
end
