module Hyrb
  module Models    
    module Cache
      class Developers < Model
        def initialize(data = nil)
          super(File.join("cache", "developers"), data)
        end

        def serialize(data)
          data.map(&:to_hash)
        end

        def deserialize(data)
          data && data.map { |d| Developer.new(d) }
        end
      end

      class DigitalOcean < Struct
        define_keys %w( flavors images regions )

        def initialize
          super(File.join("cache", "digital_ocean"))
        end
      end

      class Rackspace < Struct
        define_keys %w( flavors images )

        def initialize
          super(File.join("cache", "rackspace"))
        end
      end
    end
  end
end