module Hyrb
  module Models
    class Developer
      ROLE_MAP = {
        1 => :admin,
        2 => :developer,
        3 => :contractor,
        4 => :banned,
      }

      attr_accessor :name, :email, :role, :github_username, :keys, :digital_ocean_id

      def initialize(hash = {})
        hash.each do |k,v|
          send("#{k}=", v)
        end
      end

      def employee?
        [:admin, :developer].include?(role)
      end

      def to_hash
        Hash[%w(name email role github_username keys).map { |a| [a, send(a)] }]
      end
    end
  end
end