module Hyrb
  module Models
    class Environment < Struct
      PROVIDERS = %w( digital_ocean rackspace )

      attr_accessor :project

      define_keys %w( name
                      host
                      domain
                      label
                      server_name
                      provider
                      server_id
                      deploy_user
                      base_path
                      relative_web_root
                      database_host
                      database_name
                      database_user
                      database_password
                      has_dns_record )

      def initialize(project, name)
        @name = name
        super(File.join("projects", project.name, "project"))
        self.project = project
        self.name = name
      end

      def serialize(data)
        project.environments[@name] = data
        project.serialize(project.data)
      end

      def deserialize(data)
        super(data["environments"][@name])
      end
    end
  end
end