module Hyrb
  module Models
    class Project < Struct
      define_keys %w( name
                      title
                      description
                      github_org
                      repo_name
                      github_team
                      room_name
                      users
                      environments
                      jira_project
                      has_hipchat_hook )

      def initialize(name)
        super(File.join("projects", name, "project"))
        self.name = name
        data.environments ||= { }
      end

      def developers(all_developers)
        users ? all_developers.select {|dev| users.include? dev.email } : []
      end

      def repo_path
        "#{github_org}/#{repo_name}"
      end

      def ansible_path
        File.join(File.dirname(path), "ansible")
      end
    end
  end
end