require 'hyrb/pipeline'
  
module Hyrb
  class Task
    extend Forwardable

    attr_reader :env, :pipeline

    def_delegators :pipeline, :invoke, :say, :ask, :prompt, :edit, :option_list, :beep, :yes?, :no?

    def self.depends(*args)
      Commands::Pipeline.rules.merge!({self => args})
    end

    def self.prompt(hash_name, key, options = {})
      self.prompts << [hash_name, key, options]
    end

    def self.prompts
      @prompts ||= []
    end

    def initialize(pipeline)
      @pipeline = pipeline
    end

    # TODO: run task after

    def run(env)
    end

    def run_before(env)
      self.class.prompts.each do |(hash_name, key, options)|
        if options.is_a?(Hash) && options[:default].respond_to?(:call)
          options[:default] = options[:default].call(env)
        end

        prompt "Please enter #{key}", env[hash_name], key, options
      end
    end
  end

  module Tasks
    Hyrb.autoload_each self, "hyrb/tasks", %w( ansible creds defaults developers digital_ocean environment github google hipchat project provision rackspace )
  end
end
