module Hyrb
  module Tasks
    module Creds
      class Inject < Task
        depends Defaults::Init

        def run(env)
          env.creds = Hyrb::Models::Creds.new
        end
      end

      class Init < Task
        depends Inject
      end

      class Show < Task
        depends Init

        def run(env)
          say env.creds.data.to_hash.to_yaml
        end
      end

      class Build < Task
        depends Init

        Hyrb::Models::Creds.keys.each do |key|
          prompt :creds, key, always: true
        end
      end

      class Edit < Task
        depends Init

        def run(env)
          edit(env.creds.filepath)
        end
      end
    end
  end
end