module Hyrb
  module Tasks
    module Defaults
      class Inject < Task
        def run(env)
          env.defaults = Hyrb::Models::Defaults.new
        end
      end

      class Init < Task
        depends Inject

        prompt :defaults, :domain, "hyfnrsx1.com"
      end

      class Show < Task
        depends Defaults::Init

        def run(env)
          say env.defaults.data.to_hash.to_yaml
        end
      end

      class Build < Task
        depends Defaults::Init

        Hyrb::Models::Defaults.keys.each { |key| prompt :defaults, key, always: true }

        def run(env)
          say "Credentials updated", :green
        end
      end

      class Edit < Task
        depends Defaults::Init

        def run(env)
          edit(env.defaults.filepath)
        end
      end
    end
  end
end