module Hyrb
  module Tasks
    module Project
      autoload :Bootstrap, "hyrb/tasks/project/bootstrap"

      class Inject < Task
        depends Creds::Init

        def run(env)
          env.project = Hyrb::Models::Project.new(env.project_name || ask("Project name"))
          env.project.save!
        end
      end

      class Init < Task
        depends Project::Inject
      end

      class Show < Task
        depends Project::Init

        def run(env)
          say env.project.data.to_hash.to_yaml
        end
      end

      class Edit < Task
        depends Project::Init

        def run(env)
          edit(env.project.filepath)
        end
      end

      class Create < Task
        depends Project::Init

        def run(env)
          prompt "Project title", env.project, :title, env.project.name.humanize
          prompt "Project description", env.project, :description
          prompt "Github org", env.project, :github_org, env.creds.github_org
          prompt "Github repo", env.project, :repo_name, env.project.name
          prompt "Hipchat room", env.project, :room_name, env.project.name
        end
      end
    end
  end
end